# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free
%define jaxwsver 2.1

Name:           sun-jaxws-2.1-api
Version:        2.1
Release:        3%{?dist}
Epoch:          0
Summary:        Java API for XML Web Services API
License:        CDDL
Group:          Development/Libraries/Java
URL:            https://jax-ws-sources.dev.java.net/
Source0:        http://download.java.net/maven/1/javax.xml.ws/java-sources/jaxws-api-2.1-sources.jar
Source1:        http://download.java.net/maven/1/javax.xml.ws/poms/jaxws-api-2.1.pom
Source2:        CDDLv1.0.html
Source3:        sun-jaxws-2.1-api-manifest.mf
Source4:        sun-jaxws-2.1-api-build.properties
Source5:        sun-jaxws-2.1-api-build.xml
Provides:       jaxws_api = %{epoch}:%{jaxwsver}
Provides:       jaxws_2_1_api = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires(post): %{_sbindir}/update-alternatives
Requires(preun): %{_sbindir}/update-alternatives
Requires:       annotation_1_0_api
Requires:       jpackage-utils
Requires:       jaxb_2_1_api
Requires:       jpackage-utils
Requires:       saaj_1_3_api
Requires:       stax_1_0_api
Requires:       ws_metadata_2_0_api
BuildRequires:  annotation_1_0_api
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  jaxb_2_1_api
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  saaj_1_3_api
BuildRequires:  stax_1_0_api
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%description
The Java API for XML-Based Web Services (JAX-WS) 2.1 
according to JSR-224 MR2.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
# FIXME: (dwalluck): this needs an alternative to %%{_javadocdir}/jaxws_2_1_api then
Provides:       jaxws-javadoc = 0:%{jaxwsver}

%description javadoc
%{summary}.

%prep
%setup -q -c 
mkdir -p src/java
mv javax src/java
cp -p %{SOURCE2} CDDLv1.0.html
cp -p %{SOURCE3} jaxws.mf
cp -p %{SOURCE4} build.properties
cp -p %{SOURCE5} build.xml

%build
export OPT_JAR_LIST=:
export CLASSPATH=$(build-classpath jaxb_2_1_api saaj_1_3_api stax_1_0_api)
%{ant} -Dbuild.sysclasspath=only release

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -p -m 644 jaxws.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap javax.xml.ws jaxws-api %{jaxwsver} JPP %{name}

(cd %{buildroot}%{_javadir} 
/bin/touch jaxws_2_1_api.jar
/bin/touch jaxws_api.jar
ln -s %{name}-%{version}.jar %{name}.jar)

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 %{SOURCE1} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr build/release/docs/javadocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%post
%{_sbindir}/update-alternatives --install %{_javadir}/jaxws_2_1_api.jar jaxws_2_1_api %{_javadir}/%{name}.jar 20100
%{_sbindir}/update-alternatives --install %{_javadir}/jaxws_api.jar jaxws_api %{_javadir}/%{name}.jar 20100
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif
%update_maven_depmap

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jaxws_2_1_api %{_javadir}/%{name}.jar
    %{_sbindir}/update-alternatives --remove jaxws_api %{_javadir}/%{name}.jar
fi

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc CDDLv1.0.html
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%ghost %{_javadir}/jaxws_2_1_api.jar
%ghost %{_javadir}/jaxws_api.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif


%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Mon Sep 27 2010 David Walluck <dwalluck@redhat.com> 0:2.1-3
- fix Requires for jpackage-utils
- fix Requires for %%{_sbindir}/update-alternatives
- fix POM name
- fix GCJ support

* Tue Apr 22 2008 Ralph Apel <r.apel at r-apel.de> - 0:2.1-2jpp
- Touch, don't link standard api alternatives

* Thu Nov 08 2007 Ralph Apel <r.apel at r-apel.de> - 0:2.1-1jpp
- First release
